## firebird-emu 1.6

=== debian/changelog ===
firebird-emu (1.6-1) unstable; urgency=low

  * Firebird Emu 1.6

 -- Fabian Vogt <fabian@ritter-vogt.de>  Sat, 18 Mar 2023 17:47:46 +0100

## firebird-emu 1.6%2B23.gb36f20d

=== emscripten/Makefile ===
CC := emcc
CXX := em++
FLAGS := -O3 --llvm-lto 3 -Wall -I.. -s USE_ZLIB=1 -s DISABLE_EXCEPTION_CATCHING=1 -s INVOKE_RUN=0 -s NO_EXIT_RUNTIME=1 -s ASSERTIONS=0 --closure 0 -s EXTRA_EXPORTED_RUNTIME_METHODS='["callMain", "cwrap"]' --pre-js firebird-utils.js
CFLAGS := -std=c11 $(FLAGS)
CXXFLAGS := -std=c++11 $(FLAGS)
LFLAGS := --emrun -s TOTAL_MEMORY=536870912
OUTPUT := firebird

CSOURCES :=    ../core/armsnippets_loader.c ../core/asmcode.c ../core/casplus.c ../core/des.c ../core/disasm.c \
	      ../core/gdbstub.c ../core/interrupt.c ../core/keypad.c ../core/lcd.c ../core/link.c ../core/mem.c \
	      ../core/misc.c ../core/mmu.c ../core/schedule.c ../core/serial.c ../core/sha256.c ../core/usb.c \
              ../core/usblink.c ../core/os/os-emscripten.c

CPPSOURCES := ../core/arm_interpreter.cpp ../core/coproc.cpp ../core/cpu.cpp ../core/debug.cpp ../core/emu.cpp \
	      ../core/flash.cpp ../core/gif.cpp ../core/thumb_interpreter.cpp ../core/usblink_queue.cpp main.cpp \
	      ../core/fieldparser.cpp

OBJS = $(patsubst %.c, %.bc, $(CSOURCES))
OBJS += $(patsubst %.cpp, %.bc, $(CPPSOURCES))

all: $(OUTPUT).js

%.bc: %.c Makefile
	$(CC) $(CFLAGS) $< -o $@

%.bc: %.cpp Makefile
	$(CXX) $(CXXFLAGS) $< -o $@

test: $(OUTPUT).js
	emrun --safe_firefox_profile --browser firefox $(OUTPUT).html

$(OUTPUT).js: $(OBJS)
	$(CC) $(CFLAGS) $(LFLAGS) $^ -o $@

clean:
	rm -f $(OBJS) $(OUTPUT).js $(OUTPUT).data $(OUTPUT).js.mem

=== headless/Makefile ===
FLAGS := -g -O3 -DBENCHMARK -Wall -I..
OUTPUT := firebird-headless

TOOLCHAIN_ARCH = $(shell LANG=C $(CC) -v 2>&1 | awk '/Target:(.*)/{ print $$2 }' | cut -d- -f1)
TRANSLATION_ENABLED ?= TRUE
SUPPORT_LINUX ?= TRUE

ifeq "$(TOOLCHAIN_ARCH)" ""
    $(error Could not determine the toolchain architecture, please specify manually)
endif

ifeq "$(TRANSLATION_ENABLED)" "TRUE"
    ifneq "$(filter i%86,$(TOOLCHAIN_ARCH))" ""
        ASMSOURCES += ../core/asmcode_x86.S
        CSOURCES += ../core/translation_x86.c
    else ifeq "$(TOOLCHAIN_ARCH)" "x86_64"
        ASMSOURCES += ../core/asmcode_x86_64.S
        CSOURCES += ../core/asmcode.c ../core/translate_x86_64.c
    else ifneq "$(filter arm%,$(TOOLCHAIN_ARCH))" ""
        ASMSOURCES += ../core/asmcode_arm.S
        CSOURCES += ../core/asmcode.c
        CPPSOURCES += ../core/translate_arm.cpp
    else ifeq "$(TOOLCHAIN_ARCH)" "aarch64"
        ASMSOURCES += ../core/asmcode_aarch64.S
        CSOURCES += ../core/asmcode.c
        CPPSOURCES += ../core/translate_aarch64.cpp
    else
        $(error Unknown architecture $(TOOLCHAIN_ARCH))
    endif
else
    CSOURCES += ../core/asmcode.c
    FLAGS += -DNO_TRANSLATION
endif

ifeq "$(SUPPORT_LINUX)" "TRUE"
    FLAGS += -DSUPPORT_LINUX
endif

CFLAGS += -std=c11 $(FLAGS)
CXXFLAGS += -std=c++11 $(FLAGS)
LFLAGS +=
LIBS := -lz

CSOURCES   += ../core/armsnippets_loader.c ../core/casplus.c ../core/des.c ../core/disasm.c ../core/gdbstub.c \
              ../core/interrupt.c ../core/lcd.c ../core/link.c ../core/mem.c ../core/misc.c \
              ../core/mmu.c ../core/schedule.c ../core/serial.c ../core/sha256.c ../core/usb.c ../core/usblink.c \
              ../core/os/os-linux.c

CPPSOURCES += ../core/arm_interpreter.cpp ../core/coproc.cpp ../core/cpu.cpp ../core/debug.cpp ../core/emu.cpp \
              ../core/flash.cpp ../core/gif.cpp ../core/thumb_interpreter.cpp ../core/usblink_queue.cpp main.cpp \
              ../core/keypad.cpp ../core/cx2.cpp ../core/usb_cx2.cpp ../core/usblink_cx2.cpp ../core/fieldparser.cpp

OBJS = $(patsubst %.S, %.o, $(ASMSOURCES))
OBJS += $(patsubst %.c, %.o, $(CSOURCES))
OBJS += $(patsubst %.cpp, %.o, $(CPPSOURCES))

all: $(OUTPUT)

%.o: %.S Makefile
	$(CC) -c $(CFLAGS) $< -o $@

%.o: %.c Makefile
	$(CC) -c $(CFLAGS) $< -o $@

%.o: %.cpp Makefile
	$(CXX) -c $(CXXFLAGS) $< -o $@

$(OUTPUT): $(OBJS)
	$(CXX) $(CXXFLAGS) $(LFLAGS) $^ $(LIBS) -o $@

clean:
	rm -f $(OBJS) $(OUTPUT)

=== debian/changelog ===
firebird-emu (1.6+23.gb36f20d-0) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Adrien <bertrand.adrien@gmail.com>  Fri, 17 Feb 2017 21:16:20 +0100

=== debian/control ===
Source: firebird-emu
Section: sectionName
Priority: optional
Maintainer: Adrien Bertrand <bertrand.adrien@gmail.com>
Homepage: https://github.com/nspire-emus/firebird
Build-Depends: debhelper (>= 9), qtbase5-dev (>= 5.9), qtdeclarative5-dev, qttools5-dev, qml-module-qtquick2, qttools5-dev-tools, zlib1g-dev

Package: firebird-emu
Architecture: any
Depends: qml-module-qtqml-models2, qml-module-qtquick-controls, qml-module-qtquick-dialogs, qml-module-qt-labs-folderlistmodel, qml-module-qt-labs-settings, qml-module-qtquick2, ${misc:Depends}, ${shlibs:Depends}
Homepage: https://github.com/nspire-emus/firebird
Description: TI-Nspire emulator
 Third-party multi-platform emulator of the ARM-based TI-Nspire calculators

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT := qt5

CFLAGS = -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

build: build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	qmake . CONFIG+=debug_info CONFIG+=nostrip PREFIX=/usr
	make
	# --- end custom part for compiling

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	make clean || true
	# --- end custom part for cleaning up

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package
	make DESTDIR=/usr/src/packages/BUILD/debian/firebird-emu/ install INSTALL_ROOT=/usr/src/packages/BUILD/debian/firebird-emu/
	# --- end custom part for installing

# Build architecture-independent files here.
binary-indep: build install
	# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
